#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_JuKunCardCFG.h"
std::auto_ptr<Fish_JuKunCardCFG> Fish_JuKunCardCFG::msSingleton(nullptr);

int Fish_JuKunCardCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JuKunCardCFGData* Fish_JuKunCardCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_JuKunCardCFGData>& Fish_JuKunCardCFG::GetMapData()
{
	return mMapData;
}

void Fish_JuKunCardCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_JuKunCardCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JuKunCardCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_JuKunCardCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunCardCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_JuKunCardCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_JuKunCardCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_JuKunCardCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_JuKunCardCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunCardCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_JuKunCardCFG* Fish_JuKunCardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JuKunCardCFG());
	}
	return msSingleton.get();
}

void Fish_JuKunCardCFG::Release()
{
	msSingleton.reset(nullptr);
}
